#include <windows.h>
#include <string>
 using namespace std;

extern "C" {
	__declspec(dllexport) char *LegtobbetVasarlo(char[]);
	__declspec(dllexport)char *LegtobbetVasaroltTermek(char []);
	__declspec(dllexport)char *AtlagosVasarlas(char []);
}

int megrendelesekSzama;
struct Megrendeles
{
	string vasarlo;
	string termek;
	int mennyiseg;
	int ar;
};


Megrendeles* feltolt(char s[])
{
	int hossz = sizeof(s)/sizeof(char);
	string str = s;
	
	hossz = str.length();
	string megrendelesek="";
    megrendelesekSzama=0;
	for(int i = 0; i< hossz; i++)
	{
		if(s[i]==';')
			megrendelesekSzama++;
	}
	Megrendeles* rendelesek = new Megrendeles[megrendelesekSzama];
	int kezd=0;
	int poz = 0;
	string temp=str;
	for (int i = 0; i < megrendelesekSzama; i++)
	{
		temp=temp.substr(kezd,hossz);
		
		poz = temp.find_first_of(',');
		rendelesek[i].vasarlo= temp.substr(0,poz);
		
		kezd=poz+1;
		temp=temp.substr(kezd,hossz);
		poz= temp.find_first_of(',');
		rendelesek[i].termek= temp.substr(0,poz);

		kezd=poz+1;
		temp=temp.substr(kezd,hossz);
		poz= temp.find_first_of(',');
		rendelesek[i].mennyiseg= atoi(temp.substr(0,poz).c_str());

		kezd=poz+1;
		temp=temp.substr(kezd,hossz);
		poz= temp.find_first_of(';');
		rendelesek[i].ar= atoi(temp.substr(0,poz).c_str());
		kezd=poz+1;
	}

	return rendelesek;
	
}

 char *stringToChar(string s)
 {
	char * output = new char[s.size()+ 1];
	copy(s.begin(), s.end(), output);
	output[s.size()] = '\0';
	return output;
 }

 string intToString(int number)
{
    if (number == 0)
        return "0";
    string temp="";
    string output="";
    while (number>0)
    {
        temp+=number%10+48;
        number/=10;
    }
    for (int i=0;i<temp.length();i++)
        output+=temp[temp.length()-i-1];
    return output;
}



 __declspec(dllexport)char *LegtobbetVasarlo(char s[]) {
	
	Megrendeles* megrendelesek= feltolt(s);
	int meret = megrendelesekSzama;
	int max = 0;
    string maxVasarlo=megrendelesek[0].vasarlo;
	string vasarlo;
	int osszeg = 0;
	for(int i=0;i<meret;i++)
	{
		vasarlo=megrendelesek[i].vasarlo;
		osszeg = 0;
		for (int j = 0; j < meret; j++)
		{
			if(megrendelesek[j].vasarlo==vasarlo)
				osszeg+=megrendelesek[j].mennyiseg*megrendelesek[j].ar;
		}
		if(osszeg>max)
		{
			max=osszeg;
			maxVasarlo=vasarlo;
		}
	}
	
	return stringToChar("A legnagyobb sszegrt vsrl gyfl: "+maxVasarlo + " Vsrlsainak ssz. rtke: "+intToString(max));
}

  __declspec(dllexport)char *LegtobbetVasaroltTermek(char s[])
 {
	Megrendeles* megrendelesek= feltolt(s);
	int meret = megrendelesekSzama;
	int max = 0;
    string maxTermek=megrendelesek[0].termek;
	string termek;
	int darab = 0;

	for(int i=0;i<meret;i++)
	{
		termek=megrendelesek[i].termek;
		darab = 0;
		for (int j = 0; j < meret; j++)
		{
			if(megrendelesek[j].termek==termek)
				darab+=megrendelesek[j].mennyiseg;
		}
		if(darab>max)
		{
			max=darab;
			maxTermek=termek;
		}
	}
	return stringToChar("A legtbbet eladott termk "+maxTermek + " sszesen "+intToString(max) +" darabot adtun el belle\n");
 }

  __declspec(dllexport)char *AtlagosVasarlas(char s[])
 {
	Megrendeles* megrendelesek= feltolt(s);
	int meret = megrendelesekSzama;
	int ossz=0;

	for(int i=0; i< meret;i++)
	{
		ossz+=megrendelesek[i].ar*megrendelesek[i].mennyiseg;
	}
	ossz/=meret;

	return stringToChar("A vsrlk tlagosan "+intToString(ossz) +"Ft.-ot kltttek\n");
 }
